


#include "GameModes/KOFDefaultGameMode.h"

#include "Kismet/GameplayStatics.h"

AKOFDefaultGameMode::AKOFDefaultGameMode()
{
	NumCharactersPerTeam = 3;

	MaxDistance = 700.0f;
	StartY = 250.0f;
}

void AKOFDefaultGameMode::InitTeams()
{
	for (TSubclassOf<AKOFBaseCharacter> CharacterTemplate : P1TeamTemplate)
	{
		AKOFBaseCharacter* Temp = GetWorld()->SpawnActor<AKOFBaseCharacter>(CharacterTemplate, FVector(0.0f, -StartY, 204.6241f), FRotator(0.0f, 90.0f, 0.0f));
		if(Temp)
		{
			P1Team.Add(Temp);
		}
	}
	
	for (TSubclassOf<AKOFBaseCharacter> CharacterTemplate : P2TeamTemplate)
	{
		AKOFBaseCharacter* Temp = GetWorld()->SpawnActor<AKOFBaseCharacter>(CharacterTemplate, FVector(0.0f, StartY, 204.6241f), FRotator(0.0f, -90.0f, 0.0f));
		Temp->AutoPossessPlayer = EAutoReceiveInput::Player1;
		if(Temp)
		{
			P2Team.Add(Temp);
		}
	}
}

void AKOFDefaultGameMode::StartPlay()
{
	Super::StartPlay();

	InitTeams();

	// is this the right place to do this?
	APlayerController* PC1 = UGameplayStatics::GetPlayerController(GetWorld(), 0);
	if(PC1)
	{
		AKOFBaseCharacter* P1 = GetP1CurrentCharacter();
		if(P1)
		{
			PC1->Possess(P1);
		}
	}

	APlayerController* PC2 = UGameplayStatics::GetPlayerController(GetWorld(), 1);
	if(PC2)
	{
		AKOFBaseCharacter* P2 = GetP1CurrentCharacter();
		if(P2)
		{
			PC2->Possess(P2);
		}
	}
}
